=== debian/changelog ===
psi-plus (1.2.248-1) unstable; urgency=medium

  * New upstream release.
  * Update debian/copyright.
  * Update Homepage filed in debian/control: http --> https.

 -- Boris Pek <tehnick@debian.org>  Wed, 28 Feb 2018 23:49:43 +0300

psi-plus (1.2.235-2) unstable; urgency=medium

  * Add Debian XMPP Maintainers to Uploaders.

 -- Boris Pek <tehnick@debian.org>  Tue, 20 Feb 2018 03:18:00 +0300

psi-plus (1.2.235-1) unstable; urgency=medium

  * New upstream release.
  * Bump debhelper version to 11~ (was 9); update debian/compat.
  * Update debian/control:
    - bump Standards-Version to 4.1.3 (was 4.1.1): no changes required
    - update Vcs-* fields: moved from GitHub to Salsa
    - add build dependency from qt5keychain-dev
  * Update debian/rules:
    - explicitly enable QtKeychain support
    - delete --parallel and --list-missing options from dh
  * Update years and Format URL in debian/copyright.

 -- Boris Pek <tehnick@debian.org>  Tue, 20 Feb 2018 02:53:18 +0300

psi-plus (1.2.105-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.1.1 (was 4.1.0): no changes required.

 -- Boris Pek <tehnick@debian.org>  Thu, 26 Oct 2017 00:41:55 +0300

psi-plus (1.2.71-1) unstable; urgency=medium

  * New upstream release:
    added workaround which fixes connection to XMPP server using manually set
    IP address. (Closes: #874481)

 -- Boris Pek <tehnick@debian.org>  Sun, 10 Sep 2017 22:54:58 +0300

psi-plus (1.2.40-1) unstable; urgency=medium

  * New upstream release:
    - fixed crash in automatic color choosing algorithm for messages from users
      with nick "_" in group chats (Closes: #799967)
    - fixed re-establishing connection to XMPP server after changing of network
      settings or enabling laptop after sleep (LP: #906870)
    - fixed frequent crashes after enabling laptop after sleep (LP: #955415)
    - fixed rare crash in case when user tries to disconnect from server during
      ongoing connection (LP: #919726)
    - added few client icons into program sources (LP: #1304842)
  * Bump Standards-Version to 4.1.0 (was 3.9.5).
  * Common changes in the package:
    - change build system from qconf to cmake
    - use hunspell instead of aspell for spell check
    - build package with Qt5 instead of Qt4:
      + QtWebKit 4.x is not used anymore (Closes: #784510)
      + libqca-qt5 is used instead of libqca2 (Closes: #789472) (LP: #1054556)
    - build package with system minizip library instead of embedded one
      (Closes: #759335)
  * debian/control:
    - update Homepage field
    - use https link in Vcs-Git
    - delete all *-dbg packages
    - update detailed description of all binary packages
    - move libqca-qt5-2-plugins from Recommends to Depends of psi-plus and
      psi-plus-webkit binary packages (Closes: #717350)
    - set Multi-Arch fields to psi-plus-common, psi-plus-skins and
      psi-plus-sounds binary packages
    - delete Replaces and Conflicts fields from package psi-plus-plugins
  * Rewrite debian/rules after switching to cmake.
  * Delete all files from source package which are not required anymore:
    mergedups.sh, psi-plus*.dirs, psi-plus*.menu, psi-plus*.xpm
  * Delete debian/patches/*: they are not required anymore.
  * Update debian/psi-plus-webkit.desktop
  * Update debian/*.install files.
  * Update debian/copyright.

 -- Boris Pek <tehnick@debian.org>  Fri, 01 Sep 2017 21:27:10 +0300

psi-plus (0.16.330-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix another FTBFS on unsigned char architectures.

 -- Andrey Rahmatullin <wrar@debian.org>  Sun, 20 Nov 2016 00:34:57 +0500

psi-plus (0.16.330-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS on unsigned char architectures.

 -- Andrey Rahmatullin <wrar@debian.org>  Sat, 19 Nov 2016 20:56:36 +0500

psi-plus (0.16.330-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Use packaged ./configure script, as qconf-2.1-1 in sid
    is incompatible with psi's build setup. Idea taken from the psi package.
    (Closes: #841557).

 -- Andrey Rahmatullin <wrar@debian.org>  Fri, 04 Nov 2016 23:02:08 +0500
