=== debian/control ===
Source: psi-plus
Section: net
Priority: optional
Maintainer: Boris Pek <tehnick@debian.org>
Uploaders: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
Build-Depends: cmake,
               debhelper (>= 11~),
               libhunspell-dev,
               libidn11-dev,
               libminizip-dev,
               libotr5-dev | libotr2-dev,
               libqca-qt5-2-dev,
               libqt5svg5-dev,
               libqt5webkit5-dev,
               libqt5x11extras5-dev,
               libsm-dev,
               libtidy-dev,
               libxss-dev,
               qt5keychain-dev,
               qtmultimedia5-dev,
               zlib1g-dev
Homepage: https://psi-plus.com/
Vcs-Git: https://salsa.debian.org/xmpp-team/psi-plus.git
Vcs-Browser: https://salsa.debian.org/xmpp-team/psi-plus
Standards-Version: 4.1.3

Package: psi-plus
Architecture: any
Depends: psi-plus-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         libqca-qt5-2-plugins
Recommends: psi-plus-l10n,
            psi-plus-plugins,
            psi-plus-sounds,
            sox
Suggests: xdg-utils
Description: Qt-based XMPP/Jabber client (basic version)
 This package contains basic version of Psi+.
 .
 Psi IM is a cross-platform powerful XMPP/Jabber client (Qt, C++) designed for
 the Jabber power users. Psi+ is a development branch of Psi client by
 <psi-dev@conference.jabber.ru> team.
 .
 Project Purpose: collection, refinement and writing new patches for
 transferring them to Psi IM upstream.
 .
 Full list of features you can found at:
 http://psi-plus.com/wiki/en:features

Package: psi-plus-webkit
Architecture: any
Depends: psi-plus-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         libqca-qt5-2-plugins
Recommends: psi-plus-l10n,
            psi-plus-plugins,
            psi-plus-skins,
            psi-plus-sounds,
            sox
Suggests: xdg-utils
Description: Qt-based XMPP/Jabber client (WebKit version)
 This package contains WebKit version of Psi+. In comparing with basic Psi+
 version it has few additional features: support of animated emoticons, support
 of (adium) themes in private chats and group chats, support of previewing of
 images and videos in private chats and group chats, etc..
 .
 Psi IM is a cross-platform powerful XMPP/Jabber client (Qt, C++) designed for
 the Jabber power users. Psi+ is a development branch of Psi client by
 <psi-dev@conference.jabber.ru> team.
 .
 Project Purpose: collection, refinement and writing new patches for
 transferring them to Psi IM upstream.
 .
 Full list of features you can found at:
 http://psi-plus.com/wiki/en:features

Package: psi-plus-common
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: common files for Psi+
 This package contains common files for Psi+.
 .
 Psi IM is a cross-platform powerful XMPP/Jabber client (Qt, C++) designed for
 the Jabber power users. Psi+ is a development branch of Psi client by
 <psi-dev@conference.jabber.ru> team.
 .
 Project Purpose: collection, refinement and writing new patches for
 transferring them to Psi IM upstream.
 .
 Full list of features you can found at:
 http://psi-plus.com/wiki/en:features

Package: psi-plus-plugins
Architecture: any
Depends: psi-plus (=${binary:Version}) | psi-plus-webkit (=${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: plugins for Psi+
 This package contains plugins for Psi+.
 .
 Psi IM is a cross-platform powerful XMPP/Jabber client (Qt, C++) designed for
 the Jabber power users. Psi+ is a development branch of Psi client by
 <psi-dev@conference.jabber.ru> team.
 .
 Project Purpose: collection, refinement and writing new patches for
 transferring them to Psi IM upstream.
 .
 Full list of features you can found at:
 http://psi-plus.com/wiki/en:features

Package: psi-plus-skins
Architecture: all
Depends: psi-plus | psi-plus-webkit, psi-plus-plugins, ${misc:Depends}
Multi-Arch: foreign
Description: skins for Psi+
 This package contains skins for Psi+.
 .
 Psi IM is a cross-platform powerful XMPP/Jabber client (Qt, C++) designed for
 the Jabber power users. Psi+ is a development branch of Psi client by
 <psi-dev@conference.jabber.ru> team.
 .
 Project Purpose: collection, refinement and writing new patches for
 transferring them to Psi IM upstream.
 .
 Full list of features you can found at:
 http://psi-plus.com/wiki/en:features

Package: psi-plus-sounds
Architecture: all
Depends: psi-plus | psi-plus-webkit, ${misc:Depends}
Multi-Arch: foreign
Description: sound files for Psi+
 This package contains sound files for Psi+.
 .
 Psi IM is a cross-platform powerful XMPP/Jabber client (Qt, C++) designed for
 the Jabber power users. Psi+ is a development branch of Psi client by
 <psi-dev@conference.jabber.ru> team.
 .
 Project Purpose: collection, refinement and writing new patches for
 transferring them to Psi IM upstream.
 .
 Full list of features you can found at:
 http://psi-plus.com/wiki/en:features
